org.codehaus.groovy.antlr

## Class GroovySourceAST

- java.lang.Object
- - antlr.BaseAST
  - - antlr.CommonAST
    - - org.codehaus.groovy.antlr.GroovySourceAST

- All Implemented Interfaces:
    AST, Serializable, Comparable, SourceInfo

      public class GroovySourceAST
      extends CommonAST
      implements Comparable, SourceInfo

  We have an AST subclass so we can track source information. Very odd that ANTLR doesn't do this by default.
  Author:
    Mike Spille, Jeremy Rayner
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class antlr.BaseAST

      `down, right`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GroovySourceAST()`
    `GroovySourceAST(Token t)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `GroovySourceAST` | `childAt(int position)`
    `GroovySourceAST` | `childOfType(int type)`
    `List<GroovySourceAST>` | `childrenOfType(int type)`
    `int` | `compareTo(Object object)`
    `int` | `getColumn()` get starting column
    `int` | `getColumnLast()` get ending column
    `int` | `getLine()` get start line
    `int` | `getLineLast()` get ending line
    `String` | `getSnippet()`
    `void` | `initialize(AST ast)`
    `void` | `initialize(Token t)`
    `void` | `setColumn(int column)` set start column
    `void` | `setColumnLast(int colLast)` set ending column
    `void` | `setLast(Token last)`
    `void` | `setLine(int line)` set start line
    `void` | `setLineLast(int lineLast)` set ending line
    `void` | `setSnippet(String snippet)`

    - ### Methods inherited from class antlr.CommonAST

      `getText, getType, initialize, setText, setType`

    - ### Methods inherited from class antlr.BaseAST

      `addChild, decode, encode, equals, equalsList, equalsListPartial, equalsTree, equalsTreePartial, findAll, findAllPartial, getFirstChild, getNextSibling, getNumberOfChildren, getTokenNames, removeChildren, setFirstChild, setNextSibling, setVerboseStringConversion, toString, toStringList, toStringTree, xmlSerialize, xmlSerializeNode, xmlSerializeRootClose, xmlSerializeRootOpen`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GroovySourceAST

          public GroovySourceAST()

    - #### GroovySourceAST

          public GroovySourceAST(Token t)

  - ### Method Detail

    - #### initialize

          public void initialize(AST ast)

      Specified by:
        `initialize` in interface `AST`
      Overrides:
        `initialize` in class `CommonAST`

    - #### initialize

          public void initialize(Token t)

      Specified by:
        `initialize` in interface `AST`
      Overrides:
        `initialize` in class `CommonAST`

    - #### setLast

          public void setLast(Token last)

    - #### getLineLast

          public int getLineLast()

      Description copied from interface: `SourceInfo`
      get ending line
      Specified by:
        `getLineLast` in interface `SourceInfo`
      Returns:
        the ending line

    - #### setLineLast

          public void setLineLast(int lineLast)

      Description copied from interface: `SourceInfo`
      set ending line
      Specified by:
        `setLineLast` in interface `SourceInfo`
      Parameters:
        `lineLast` - the line

    - #### getColumnLast

          public int getColumnLast()

      Description copied from interface: `SourceInfo`
      get ending column
      Specified by:
        `getColumnLast` in interface `SourceInfo`
      Returns:
        the ending column

    - #### setColumnLast

          public void setColumnLast(int colLast)

      Description copied from interface: `SourceInfo`
      set ending column
      Specified by:
        `setColumnLast` in interface `SourceInfo`
      Parameters:
        `colLast` - the column

    - #### setLine

          public void setLine(int line)

      Description copied from interface: `SourceInfo`
      set start line
      Specified by:
        `setLine` in interface `SourceInfo`
      Parameters:
        `line` - the line

    - #### getLine

          public int getLine()

      Description copied from interface: `SourceInfo`
      get start line
      Specified by:
        `getLine` in interface `AST`
      Specified by:
        `getLine` in interface `SourceInfo`
      Overrides:
        `getLine` in class `BaseAST`
      Returns:
        the starting line

    - #### setColumn

          public void setColumn(int column)

      Description copied from interface: `SourceInfo`
      set start column
      Specified by:
        `setColumn` in interface `SourceInfo`
      Parameters:
        `column` - the column

    - #### getColumn

          public int getColumn()

      Description copied from interface: `SourceInfo`
      get starting column
      Specified by:
        `getColumn` in interface `AST`
      Specified by:
        `getColumn` in interface `SourceInfo`
      Overrides:
        `getColumn` in class `BaseAST`
      Returns:
        the starting column

    - #### setSnippet

          public void setSnippet(String snippet)

    - #### getSnippet

          public String getSnippet()

    - #### compareTo

          public int compareTo(Object object)

      Specified by:
        `compareTo` in interface `Comparable`

    - #### childAt

          public GroovySourceAST childAt(int position)

    - #### childOfType

          public GroovySourceAST childOfType(int type)

    - #### childrenOfType

          public List<GroovySourceAST> childrenOfType(int type)